#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ucontext.h>
#include <unistd.h>

/*
 * $Id$
 */

/*
 * $Log$
 */



/*
 * From Linux kernel
 */
#define _NSIG           64
#define _NSIG_BPW       32
#define _NSIG_WORDS     (_NSIG / _NSIG_BPW)
struct sigframe {
	char			*pretcode;
	int			sig;
	struct sigcontext	sc;
	struct _fpstate		fpstate;
	unsigned long		extramask[_NSIG_WORDS-1];
	char			retcode[8];
};
/*
 * End of code stolen from the Linux kernel
 */

#ifdef DEBUG
#define DEBUGF(format...)						\
	do {								\
		fprintf(stderr, "%s(%d):%s(): ", __FILE__, __LINE__,	\
				__FUNCTION__);				\
			fprintf(stderr, ##format);			\
	} while(0)
#else
#define DEBUGF(format...)
#endif


#if 0
class Ccall_early {
	public:
			Ccall_early(long i);
		long	get_value(void);
	private:
		long	value;
};

Ccall_early::Ccall_early(long i)
{
	struct sigaction	sa_action;
	int			ret;

	bzero(&sa_action, sizeof(sa_action));
	sa_action.sa_sigaction = &handle_sigill;
	sa_action.sa_flags = SA_SIGINFO;
	ret = sigaction(SIGILL, &sa_action, NULL);
	
	DEBUGF("sigill started, sigaction() = %d\n", ret);
	value = i;

	return;
}

long
Ccall_early::get_value(void)
{
	return value;
}

/*
 * We need to run _really_ early, even before all those _init() calls.
 * Doing it with some constructor is a hack to achieve this...
 */
static Ccall_early	call_early(9);
#endif /* 0 */

static void handle_sigill(int signr, siginfo_t *si, void *context);



static int
do_set_handler(void)
{
	struct sigaction	sa_action;
	int			ret;

	bzero(&sa_action, sizeof(sa_action));
	sa_action.sa_sigaction = &handle_sigill;
	sa_action.sa_flags = SA_SIGINFO;
	ret = sigaction(SIGILL, &sa_action, NULL);
	
	DEBUGF("sigill started, sigaction() = %d\n", ret);

	return ret;
}

static void
handle_sigill(int signr, siginfo_t *si, void *context)
{
	unsigned long	local;
	struct sigframe	sframe;
	size_t		offset;
	unsigned long	*insn;

	offset = (char *)&sframe.sc.eip - (char *)&sframe;

	//insn = (unsigned long *)si->sc.eip;

	DEBUGF("Got SIG%d, offset = %d, insn = %ld, ctx = %p\n", signr, offset,
			*insn, context);

	return;
}

void
_init(void)
{
	DEBUGF("_init() called\n");

	do_set_handler();

	return;
}

